import { Ref } from '@vue/composition-api';
interface Options<T> {
    pendingDelay?: number | Ref<number>;
    promise?: Promise<T> | Ref<Promise<T>>;
}
export declare function usePromise<T>(options?: Readonly<Options<T>>): {
    state: {
        promise: {
            then: <TResult1 = T, TResult2 = never>(onfulfilled?: ((value: T) => TResult1 | PromiseLike<TResult1>) | null | undefined, onrejected?: ((reason: any) => TResult2 | PromiseLike<TResult2>) | null | undefined) => Promise<TResult1 | TResult2>;
            catch: <TResult = never>(onrejected?: ((reason: any) => TResult | PromiseLike<TResult>) | null | undefined) => Promise<T | TResult>;
            finally: (onfinally?: (() => void) | null | undefined) => Promise<T>;
        } | null;
        isPending: boolean;
        data: (T extends Ref<infer V> ? V extends Ref<infer V_1> ? V_1 extends Ref<infer V_2> ? V_2 extends Ref<infer V_3> ? V_3 extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_3 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3 : V_3 extends object ? { [K_3 in keyof V_3]: V_3[K_3] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_3[K_3] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3] : V_3[K_3] extends object ? { [K_4 in keyof V_3[K_3]]: V_3[K_3][K_4] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_3[K_3][K_4] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3][K_4] : V_3[K_3][K_4] extends object ? { [K_5 in keyof V_3[K_3][K_4]]: V_3[K_3][K_4][K_5] extends Ref<infer V_7> ? V_7 : V_3[K_3][K_4][K_5]; } : V_3[K_3][K_4]; } : V_3[K_3]; } : V_3 : V_2 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2 : V_2 extends object ? { [K_6 in keyof V_2]: V_2[K_6] extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_2[K_6] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2[K_6] : V_2[K_6] extends object ? { [K_7 in keyof V_2[K_6]]: V_2[K_6][K_7] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_2[K_6][K_7] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2[K_6][K_7] : V_2[K_6][K_7] extends object ? { [K_8 in keyof V_2[K_6][K_7]]: V_2[K_6][K_7][K_8] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_2[K_6][K_7][K_8] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2[K_6][K_7][K_8] : V_2[K_6][K_7][K_8] extends object ? { [K_9 in keyof V_2[K_6][K_7][K_8]]: V_2[K_6][K_7][K_8][K_9] extends Ref<infer V_7> ? V_7 : V_2[K_6][K_7][K_8][K_9]; } : V_2[K_6][K_7][K_8]; } : V_2[K_6][K_7]; } : V_2[K_6]; } : V_2 : V_1 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_1 : V_1 extends object ? { [K_10 in keyof V_1]: V_1[K_10] extends Ref<infer V_3> ? V_3 extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_3 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3 : V_3 extends object ? { [K_3 in keyof V_3]: V_3[K_3] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_3[K_3] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3] : V_3[K_3] extends object ? { [K_4 in keyof V_3[K_3]]: V_3[K_3][K_4] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_3[K_3][K_4] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3][K_4] : V_3[K_3][K_4] extends object ? { [K_5 in keyof V_3[K_3][K_4]]: V_3[K_3][K_4][K_5] extends Ref<infer V_7> ? V_7 : V_3[K_3][K_4][K_5]; } : V_3[K_3][K_4]; } : V_3[K_3]; } : V_3 : V_1[K_10] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_1[K_10] : V_1[K_10] extends object ? { [K_11 in keyof V_1[K_10]]: V_1[K_10][K_11] extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_1[K_10][K_11] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_1[K_10][K_11] : V_1[K_10][K_11] extends object ? { [K_12 in keyof V_1[K_10][K_11]]: V_1[K_10][K_11][K_12] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_1[K_10][K_11][K_12] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_1[K_10][K_11][K_12] : V_1[K_10][K_11][K_12] extends object ? { [K_13 in keyof V_1[K_10][K_11][K_12]]: V_1[K_10][K_11][K_12][K_13] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_1[K_10][K_11][K_12][K_13] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_1[K_10][K_11][K_12][K_13] : V_1[K_10][K_11][K_12][K_13] extends object ? { [K_14 in keyof V_1[K_10][K_11][K_12][K_13]]: V_1[K_10][K_11][K_12][K_13][K_14] extends Ref<infer V_7> ? V_7 : V_1[K_10][K_11][K_12][K_13][K_14]; } : V_1[K_10][K_11][K_12][K_13]; } : V_1[K_10][K_11][K_12]; } : V_1[K_10][K_11]; } : V_1[K_10]; } : V_1 : V extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V : V extends object ? { [K_15 in keyof V]: V[K_15] extends Ref<infer V_2> ? V_2 extends Ref<infer V_3> ? V_3 extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_3 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3 : V_3 extends object ? { [K_3 in keyof V_3]: V_3[K_3] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_3[K_3] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3] : V_3[K_3] extends object ? { [K_4 in keyof V_3[K_3]]: V_3[K_3][K_4] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_3[K_3][K_4] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3][K_4] : V_3[K_3][K_4] extends object ? { [K_5 in keyof V_3[K_3][K_4]]: V_3[K_3][K_4][K_5] extends Ref<infer V_7> ? V_7 : V_3[K_3][K_4][K_5]; } : V_3[K_3][K_4]; } : V_3[K_3]; } : V_3 : V_2 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2 : V_2 extends object ? { [K_6 in keyof V_2]: V_2[K_6] extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_2[K_6] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2[K_6] : V_2[K_6] extends object ? { [K_7 in keyof V_2[K_6]]: V_2[K_6][K_7] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_2[K_6][K_7] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2[K_6][K_7] : V_2[K_6][K_7] extends object ? { [K_8 in keyof V_2[K_6][K_7]]: V_2[K_6][K_7][K_8] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_2[K_6][K_7][K_8] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2[K_6][K_7][K_8] : V_2[K_6][K_7][K_8] extends object ? { [K_9 in keyof V_2[K_6][K_7][K_8]]: V_2[K_6][K_7][K_8][K_9] extends Ref<infer V_7> ? V_7 : V_2[K_6][K_7][K_8][K_9]; } : V_2[K_6][K_7][K_8]; } : V_2[K_6][K_7]; } : V_2[K_6]; } : V_2 : V[K_15] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V[K_15] : V[K_15] extends object ? { [K_16 in keyof V[K_15]]: V[K_15][K_16] extends Ref<infer V_3> ? V_3 extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_3 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3 : V_3 extends object ? { [K_3 in keyof V_3]: V_3[K_3] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_3[K_3] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3] : V_3[K_3] extends object ? { [K_4 in keyof V_3[K_3]]: V_3[K_3][K_4] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_3[K_3][K_4] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3][K_4] : V_3[K_3][K_4] extends object ? { [K_5 in keyof V_3[K_3][K_4]]: V_3[K_3][K_4][K_5] extends Ref<infer V_7> ? V_7 : V_3[K_3][K_4][K_5]; } : V_3[K_3][K_4]; } : V_3[K_3]; } : V_3 : V[K_15][K_16] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V[K_15][K_16] : V[K_15][K_16] extends object ? { [K_17 in keyof V[K_15][K_16]]: V[K_15][K_16][K_17] extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V[K_15][K_16][K_17] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V[K_15][K_16][K_17] : V[K_15][K_16][K_17] extends object ? { [K_18 in keyof V[K_15][K_16][K_17]]: V[K_15][K_16][K_17][K_18] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V[K_15][K_16][K_17][K_18] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V[K_15][K_16][K_17][K_18] : V[K_15][K_16][K_17][K_18] extends object ? { [K_19 in keyof V[K_15][K_16][K_17][K_18]]: V[K_15][K_16][K_17][K_18][K_19] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V[K_15][K_16][K_17][K_18][K_19] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V[K_15][K_16][K_17][K_18][K_19] : V[K_15][K_16][K_17][K_18][K_19] extends object ? { [K_20 in keyof V[K_15][K_16][K_17][K_18][K_19]]: V[K_15][K_16][K_17][K_18][K_19][K_20] extends Ref<infer V_7> ? V_7 : V[K_15][K_16][K_17][K_18][K_19][K_20]; } : V[K_15][K_16][K_17][K_18][K_19]; } : V[K_15][K_16][K_17][K_18]; } : V[K_15][K_16][K_17]; } : V[K_15][K_16]; } : V[K_15]; } : V : T extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? T : T extends object ? { [K_21 in keyof T]: T[K_21] extends Ref<infer V_1> ? V_1 extends Ref<infer V_2> ? V_2 extends Ref<infer V_3> ? V_3 extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_3 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3 : V_3 extends object ? { [K_3 in keyof V_3]: V_3[K_3] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_3[K_3] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3] : V_3[K_3] extends object ? { [K_4 in keyof V_3[K_3]]: V_3[K_3][K_4] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_3[K_3][K_4] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3][K_4] : V_3[K_3][K_4] extends object ? { [K_5 in keyof V_3[K_3][K_4]]: V_3[K_3][K_4][K_5] extends Ref<infer V_7> ? V_7 : V_3[K_3][K_4][K_5]; } : V_3[K_3][K_4]; } : V_3[K_3]; } : V_3 : V_2 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2 : V_2 extends object ? { [K_6 in keyof V_2]: V_2[K_6] extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_2[K_6] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2[K_6] : V_2[K_6] extends object ? { [K_7 in keyof V_2[K_6]]: V_2[K_6][K_7] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_2[K_6][K_7] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2[K_6][K_7] : V_2[K_6][K_7] extends object ? { [K_8 in keyof V_2[K_6][K_7]]: V_2[K_6][K_7][K_8] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_2[K_6][K_7][K_8] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2[K_6][K_7][K_8] : V_2[K_6][K_7][K_8] extends object ? { [K_9 in keyof V_2[K_6][K_7][K_8]]: V_2[K_6][K_7][K_8][K_9] extends Ref<infer V_7> ? V_7 : V_2[K_6][K_7][K_8][K_9]; } : V_2[K_6][K_7][K_8]; } : V_2[K_6][K_7]; } : V_2[K_6]; } : V_2 : V_1 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_1 : V_1 extends object ? { [K_10 in keyof V_1]: V_1[K_10] extends Ref<infer V_3> ? V_3 extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_3 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3 : V_3 extends object ? { [K_3 in keyof V_3]: V_3[K_3] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_3[K_3] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3] : V_3[K_3] extends object ? { [K_4 in keyof V_3[K_3]]: V_3[K_3][K_4] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_3[K_3][K_4] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3][K_4] : V_3[K_3][K_4] extends object ? { [K_5 in keyof V_3[K_3][K_4]]: V_3[K_3][K_4][K_5] extends Ref<infer V_7> ? V_7 : V_3[K_3][K_4][K_5]; } : V_3[K_3][K_4]; } : V_3[K_3]; } : V_3 : V_1[K_10] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_1[K_10] : V_1[K_10] extends object ? { [K_11 in keyof V_1[K_10]]: V_1[K_10][K_11] extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_1[K_10][K_11] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_1[K_10][K_11] : V_1[K_10][K_11] extends object ? { [K_12 in keyof V_1[K_10][K_11]]: V_1[K_10][K_11][K_12] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_1[K_10][K_11][K_12] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_1[K_10][K_11][K_12] : V_1[K_10][K_11][K_12] extends object ? { [K_13 in keyof V_1[K_10][K_11][K_12]]: V_1[K_10][K_11][K_12][K_13] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_1[K_10][K_11][K_12][K_13] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_1[K_10][K_11][K_12][K_13] : V_1[K_10][K_11][K_12][K_13] extends object ? { [K_14 in keyof V_1[K_10][K_11][K_12][K_13]]: V_1[K_10][K_11][K_12][K_13][K_14] extends Ref<infer V_7> ? V_7 : V_1[K_10][K_11][K_12][K_13][K_14]; } : V_1[K_10][K_11][K_12][K_13]; } : V_1[K_10][K_11][K_12]; } : V_1[K_10][K_11]; } : V_1[K_10]; } : V_1 : T[K_21] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? T[K_21] : T[K_21] extends object ? { [K_22 in keyof T[K_21]]: T[K_21][K_22] extends Ref<infer V_2> ? V_2 extends Ref<infer V_3> ? V_3 extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_3 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3 : V_3 extends object ? { [K_3 in keyof V_3]: V_3[K_3] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_3[K_3] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3] : V_3[K_3] extends object ? { [K_4 in keyof V_3[K_3]]: V_3[K_3][K_4] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_3[K_3][K_4] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3][K_4] : V_3[K_3][K_4] extends object ? { [K_5 in keyof V_3[K_3][K_4]]: V_3[K_3][K_4][K_5] extends Ref<infer V_7> ? V_7 : V_3[K_3][K_4][K_5]; } : V_3[K_3][K_4]; } : V_3[K_3]; } : V_3 : V_2 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2 : V_2 extends object ? { [K_6 in keyof V_2]: V_2[K_6] extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_2[K_6] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2[K_6] : V_2[K_6] extends object ? { [K_7 in keyof V_2[K_6]]: V_2[K_6][K_7] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_2[K_6][K_7] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2[K_6][K_7] : V_2[K_6][K_7] extends object ? { [K_8 in keyof V_2[K_6][K_7]]: V_2[K_6][K_7][K_8] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_2[K_6][K_7][K_8] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_2[K_6][K_7][K_8] : V_2[K_6][K_7][K_8] extends object ? { [K_9 in keyof V_2[K_6][K_7][K_8]]: V_2[K_6][K_7][K_8][K_9] extends Ref<infer V_7> ? V_7 : V_2[K_6][K_7][K_8][K_9]; } : V_2[K_6][K_7][K_8]; } : V_2[K_6][K_7]; } : V_2[K_6]; } : V_2 : T[K_21][K_22] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? T[K_21][K_22] : T[K_21][K_22] extends object ? { [K_23 in keyof T[K_21][K_22]]: T[K_21][K_22][K_23] extends Ref<infer V_3> ? V_3 extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : V_3 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3 : V_3 extends object ? { [K_3 in keyof V_3]: V_3[K_3] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_3[K_3] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3] : V_3[K_3] extends object ? { [K_4 in keyof V_3[K_3]]: V_3[K_3][K_4] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_3[K_3][K_4] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_3[K_3][K_4] : V_3[K_3][K_4] extends object ? { [K_5 in keyof V_3[K_3][K_4]]: V_3[K_3][K_4][K_5] extends Ref<infer V_7> ? V_7 : V_3[K_3][K_4][K_5]; } : V_3[K_3][K_4]; } : V_3[K_3]; } : V_3 : T[K_21][K_22][K_23] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? T[K_21][K_22][K_23] : T[K_21][K_22][K_23] extends object ? { [K_24 in keyof T[K_21][K_22][K_23]]: T[K_21][K_22][K_23][K_24] extends Ref<infer V_4> ? V_4 extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : V_4 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4 : V_4 extends object ? { [K_1 in keyof V_4]: V_4[K_1] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_4[K_1] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_4[K_1] : V_4[K_1] extends object ? { [K_2 in keyof V_4[K_1]]: V_4[K_1][K_2] extends Ref<infer V_7> ? V_7 : V_4[K_1][K_2]; } : V_4[K_1]; } : V_4 : T[K_21][K_22][K_23][K_24] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? T[K_21][K_22][K_23][K_24] : T[K_21][K_22][K_23][K_24] extends object ? { [K_25 in keyof T[K_21][K_22][K_23][K_24]]: T[K_21][K_22][K_23][K_24][K_25] extends Ref<infer V_5> ? V_5 extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : V_5 extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? V_5 : V_5 extends object ? { [K in keyof V_5]: V_5[K] extends Ref<infer V_7> ? V_7 : V_5[K]; } : V_5 : T[K_21][K_22][K_23][K_24][K_25] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? T[K_21][K_22][K_23][K_24][K_25] : T[K_21][K_22][K_23][K_24][K_25] extends object ? { [K_26 in keyof T[K_21][K_22][K_23][K_24][K_25]]: T[K_21][K_22][K_23][K_24][K_25][K_26] extends Ref<infer V_6> ? V_6 extends Ref<infer V_7> ? V_7 : V_6 : T[K_21][K_22][K_23][K_24][K_25][K_26] extends Function | Map<any, any> | Set<any> | WeakMap<any, any> | WeakSet<any> ? T[K_21][K_22][K_23][K_24][K_25][K_26] : T[K_21][K_22][K_23][K_24][K_25][K_26] extends object ? { [K_27 in keyof T[K_21][K_22][K_23][K_24][K_25][K_26]]: T[K_21][K_22][K_23][K_24][K_25][K_26][K_27] extends Ref<infer V_7> ? V_7 : T[K_21][K_22][K_23][K_24][K_25][K_26][K_27]; } : T[K_21][K_22][K_23][K_24][K_25][K_26]; } : T[K_21][K_22][K_23][K_24][K_25]; } : T[K_21][K_22][K_23][K_24]; } : T[K_21][K_22][K_23]; } : T[K_21][K_22]; } : T[K_21]; } : T) | null;
        error: {
            name: string;
            message: string;
            stack?: string | undefined;
        } | null;
        isDelayOver: boolean;
    };
    options: {
        pendingDelay: number;
    };
    set: (p: Promise<T>) => Promise<T>;
};
export {};
